#include "gideros.h"
#include "lua.h"
#include "lauxlib.h"

static int addtwo(lua_State *L)
{
    int x = lua_tointeger (L, 1);
    int y = lua_tointeger (L, 2);
    lua_pushinteger (L, x+y);
    return 1;
}

static const struct luaL_Reg funcs[] = {
  { "addtwo",	addtwo },
  { NULL, NULL }
};

static int loader(lua_State *L)
{
    luaL_register(L, "addtwo", funcs);

    return 1;
}

static void g_initializePlugin(lua_State *L)
{
    lua_getglobal(L, "package");
    lua_getfield(L, -1, "preload");

    lua_pushcfunction(L, loader);
    lua_setfield(L, -2, "addtwo");

    lua_pop(L, 2);
}

static void g_deinitializePlugin(lua_State *L)
{
}
REGISTER_PLUGIN("AddTwo", "1.0")
